                  PROGRAM

                  MAP
                  END

SourceName        STRING(80)
MyLongFile        STRING(80)
TargetName        STRING(80)
Count             LONG
LineNo            LONG
TotalLines        LONG
FromChain         STRING(7)

TxaFiles          QUEUE(File:queue),PRE(Fil)     !Inherit exact declaration of File:queue
                  END

LP                LONG
Recs              LONG

Text                FILE,DRIVER('ASCII'),NAME(SourceName),PRE(IN)
RECORD                RECORD
Line                    STRING(120)
                      END
                    END

ProcList            FILE,DRIVER('TOPSPEED'),NAME(TargetName),CREATE,PRE(Pro)
KeyModule             KEY(+Pro:Module,+Pro:Name),OPT,NOCASE,PRIMARY
KeyName               KEY(+Pro:Name,+Pro:Module),NOCASE
KeyCategory           KEY(+Pro:Category,+Pro:Name),DUP,NOCASE
KeyDate               KEY(+Pro:Date,+Pro:Time),DUP,NOCASE
RECORD                RECORD
Module                  STRING(12)
Name                    STRING(30)
Category                STRING(15)
NoExport                STRING(8)
Date                    LONG
Time                    LONG
Description             STRING(120)
                      END
                    END

PROGRESS WINDOW('Importing Text Procedures'),AT(,,200,92),FONT('MS Sans Serif',8,,),CENTER,GRAY,DOUBLE
       STRING('Count:'),AT(70,14)
       STRING(@s10),AT(100,14),USE(LP),LEFT
       STRING('Module:'),AT(66,25)
       STRING(@s12),AT(100,25),USE(Pro:Module),LEFT
       STRING('Name:'),AT(70,36),USE(?String9)
       STRING(@s12),AT(100,36),USE(Pro:Name),LEFT
       STRING('Importing Procedure:'),AT(26,47)
       STRING(@n8),AT(100,47),USE(Count)
       STRING('Line Number:'),AT(50,58)
       STRING(@n8),AT(100,58),USE(LineNo)
       STRING('Total Lines:'),AT(55,69)
       STRING(@n8),AT(100,69),USE(TotalLines)
     END

  CODE
  TargetName = 'ProcList.TPS'
  CREATE(ProcList)
  IF ERRORCODE()
    MESSAGE('Error = ' & ERRORCODE() & ': ' & ERROR(),'CREATE(ProcList)',ICON:Exclamation)
    RETURN
  END
  OPEN(ProcList)
  IF ERRORCODE()
    MESSAGE('Error = ' & ERRORCODE() & ': ' & ERROR(),'OPEN(ProcList)',ICON:Exclamation)
    STOP
  END
  STREAM(ProcList)

  OPEN(Progress)

  DIRECTORY(TxaFiles,'*.txa',ff_:NORMAL)            ! Get all Application Text files
  LOOP LP = 1 TO RECORDS(TxaFiles)
    GET(TxaFiles,LP)
    DO ImportText
  END

  FLUSH(ProcList)
  BUILD(ProcList)
  IF ERRORCODE()
    MESSAGE('Error = ' & ERRORCODE() & ': ' & ERROR(),'CREATE(ProcList)',ICON:Exclamation)
  END
  CLOSE(ProcList)
  MESSAGE('End of Convert TXAs','Conv_Txa',ICON:Asterisk)

ImportText ROUTINE
  SourceName = Fil:ShortName
  MyLongFile = SUB(LONGPATH(SourceName),4,60)
  MyLongFile = SUB(MyLongFile,INSTRING('\',MyLongFile)+1,50)
  MyLongFile = SUB(MyLongFile,1,INSTRING('.',MyLongFile)-1)
  !MESSAGE('SourceName = ' & SourceName & |
  !  '|MyLongFile = ' & MyLongFile,'ImportText ROUTINE ' & LP,ICON:Asterisk)

  TotalLines += LineNo
  LineNo = 0
  OPEN(Text)
  IF ERRORCODE()
    MESSAGE('Error = ' & ERRORCODE() & ': ' & ERROR(),'OPEN(Text)',ICON:Exclamation)
    STOP
  END
  SET(Text)

  NEXT(Text)
  LineNo += 1
  IF IN:Line[1:13] NOT = '[APPLICATION]'
    CLOSE(Text)
    EXIT
  END

  STREAM(Text)
  LOOP
    NEXT(Text)
    IF ERRORCODE() THEN BREAK.
    LineNo += 1

    IF IN:Line[1:11] = '[PROCEDURE]'
      CLEAR(Pro:Record)
      NEXT(Text)
      IF ERRORCODE()
        MESSAGE('Error = ' & ERRORCODE() & ': ' & ERROR(),'After [PROCEDURE]',ICON:Exclamation)
        BREAK
      END
      LineNo += 1
      !Pro:Module = SUB(Fil:ShortName,1,INSTRING('.',Fil:ShortName)-1)
      Pro:Module = MyLongFile
      Pro:Name = IN:Line[6:35]
      !IF Pro:Name = 'SplishSplash'
      !  MESSAGE('Pro:Name = ' & Pro:Name,'Step 2',ICON:Asterisk)
      !END
      LOOP
        NEXT(Text)
        IF ERRORCODE() THEN BREAK.
        LineNo += 1
        IF IN:Line = 'NOEXPORT'
          Pro:NoExport = 'NoExport'
        END
        IF IN:Line = '[COMMON]'
          BREAK
        END
      END
      IF ERRORCODE() THEN BREAK.
      NEXT(Text)
      IF ERRORCODE() THEN BREAK.
      LineNo += 1
      IF IN:Line[1:11] = 'DESCRIPTION'
        Pro:DESCRIPTION = IN:Line[14:113]
        Pro:DESCRIPTION = SUB(Pro:DESCRIPTION,1,LEN(CLIP(Pro:DESCRIPTION))-1)
      END

      LOOP
        IF IN:Line[1:8] = 'FROM ABC'
          FromChain = 'ABC'
          BREAK
        END
        IF IN:Line[1:12] = 'FROM Clarion'
          FromChain = 'Clarion'
          BREAK
        END
        NEXT(Text)
        IF ERRORCODE() THEN BREAK.
        LineNo += 1
      END

      IF ERRORCODE() THEN BREAK.
      CASE FromChain
      OF 'ABC'; Pro:CATEGORY = IN:Line[10:19]
      OF 'Clarion'; Pro:CATEGORY = IN:Line[14:23]
      END
      NEXT(Text)
      IF ERRORCODE() THEN BREAK.
      LineNo += 1
      IF IN:Line[1:8] = 'CATEGORY'
        Pro:CATEGORY = IN:Line[11:25]
        Pro:CATEGORY = SUB(Pro:CATEGORY,1,LEN(CLIP(Pro:CATEGORY))-1)
        NEXT(Text)
        IF ERRORCODE() THEN BREAK.
        LineNo += 1
      END
      IF IN:Line[1:8] = 'MODIFIED'
        Pro:DATE = DEFORMAT(IN:Line[11:20],@D10)
        Pro:TIME = DEFORMAT(IN:Line[24:31],@T4)
      END

    ELSE
      CYCLE
    END

    ADD(ProcList)
    IF ERRORCODE()
      MESSAGE('Pro:Module = ' & Pro:Module & |
        '|Pro:Name = ' & Pro:Name & |
        '|Error = ' & ERRORCODE() & ': ' & ERROR(),'ADD(ProcList)',ICON:Exclamation)
      RETURN
    END
    Count += 1
    DISPLAY
  END

  CLOSE(Text)
